Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/builder.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -1210,567 +1314,621 @@
 static int ParseCommandLineOptions(int argc, char **argv, MoleculeListClass *&molecules, periodentafel *&periode, config& configuration, char *&ConfigFileName)
 {
-	Vector x,y,z,n;	// coordinates for absolute point in cell volume
-	double *factor; // unit factor if desired
-	ifstream test;
-	ofstream output;
-	string line;
-	atom *first;
-	bool SaveFlag = false;
-	int ExitFlag = 0;
-	int j;
-	double volume = 0.;
-	enum ConfigStatus config_present = absent;
-	clock_t start,end;
-	int argptr;
+  Vector x,y,z,n;  // coordinates for absolute point in cell volume
+  double *factor; // unit factor if desired
+  ifstream test;
+  ofstream output;
+  string line;
+  atom *first;
+  bool SaveFlag = false;
+  int ExitFlag = 0;
+  int j;
+  double volume = 0.;
+  enum ConfigStatus config_present = absent;
+  clock_t start,end;
+  int argptr;
+  molecule *mol = NULL;
   strncpy(configuration.databasepath, LocalPath, MAXSTRINGSIZE-1);
 
-	// simply create a new molecule, wherein the config file is loaded and the manipulation takes place
-	molecule *mol = new molecule(periode);
-	molecules->insert(mol);
-
-	if (argc > 1) { // config file specified as option
-		// 1. : Parse options that just set variables or print help
-		argptr = 1;
-		do {
-			if (argv[argptr][0] == '-') {
-				cout << Verbose(0) << "Recognized command line argument: " << argv[argptr][1] << ".\n";
-				argptr++;
-				switch(argv[argptr-1][1]) {
-					case 'h':
-					case 'H':
-					case '?':
-						cout << "MoleCuilder suite" << endl << "==================" << endl << endl;
-						cout << "Usage: " << argv[0] << "[config file] [-{acefpsthH?vfrp}] [further arguments]" << endl;
-						cout << "or simply " << argv[0] << " without arguments for interactive session." << endl;
-						cout << "\t-a Z x1 x2 x3\tAdd new atom of element Z at coordinates (x1,x2,x3)." << endl;
-						cout << "\t-A <source>\tCreate adjacency list from bonds parsed from 'dbond'-style file." <<endl;
-						cout << "\t-b x1 x2 x3\tCenter atoms in domain with given edge lengths of (x1,x2,x3)." << endl;
-						cout << "\t-B <basis>\tSetting basis to store to MPQC config files." << endl;
-						cout << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl;
-						cout << "\t-D <bond distance>\tDepth-First-Search Analysis of the molecule, giving cycles and tree/back edges." << endl;
-						cout << "\t-O\tCenter atoms in origin." << endl;
-						cout << "\t-d x1 x2 x3\tDuplicate cell along each axis by given factor." << endl;
-						cout << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl;
-						cout << "\t-E <id> <Z>\tChange atom <id>'s element to <Z>, <id> begins at 0." << endl;
-						cout << "\t-f/F <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl;
-						cout << "\t-h/-H/-?\tGive this help screen." << endl;
-						cout << "\t-m <0/1>\tCalculate (0)/ Align in(1) PAS with greatest EV along z axis." << endl;
-						cout << "\t-n\tFast parsing (i.e. no trajectories are looked for)." << endl;
-						cout << "\t-N\tGet non-convex-envelope." << endl;
-						cout << "\t-o <out>\tGet volume of the convex envelope (and store to tecplot file)." << endl;
-						cout << "\t-p <file>\tParse given xyz file and create raw config file from it." << endl;
-						cout << "\t-P <file>\tParse given forces file and append as an MD step to config file via Verlet." << endl;
-						cout << "\t-r\t\tConvert file from an old pcp syntax." << endl;
-						cout << "\t-t x1 x2 x3\tTranslate all atoms by this vector (x1,x2,x3)." << endl;
-						cout << "\t-T <file> Store temperatures from the config file in <file>." << endl;
-						cout << "\t-s x1 x2 x3\tScale all atom coordinates by this vector (x1,x2,x3)." << endl;
-						cout << "\t-u rho\tsuspend in water solution and output necessary cell lengths, average density rho and repetition." << endl;
-						cout << "\t-v/-V\t\tGives version information." << endl;
-						cout << "Note: config files must not begin with '-' !" << endl;
-						delete(mol);
-						delete(periode);
-						return (1);
-						break;
-					case 'v':
-					case 'V':
-						cout << argv[0] << " " << VERSIONSTRING << endl;
-						cout << "Build your own molecule position set." << endl;
-						delete(mol);
-						delete(periode);
-						return (1);
-						break;
-					case 'e':
-						if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-							cerr << "Not enough or invalid arguments for specifying element db: -e <db file>" << endl;
-						} else {
-							cout << "Using " << argv[argptr] << " as elements database." << endl;
-							strncpy (configuration.databasepath, argv[argptr], MAXSTRINGSIZE-1);
-							argptr+=1;
-						}
-						break;
-					case 'n':
-						cout << "I won't parse trajectories." << endl;
-						configuration.FastParsing = true;
-						break;
-					default:	 // no match? Step on
-						argptr++;
-						break;
-				}
-			} else
-				argptr++;
-		} while (argptr < argc);
-
-		// 2. Parse the element database
-		if (periode->LoadPeriodentafel(configuration.databasepath)) {
-			cout << Verbose(0) << "Element list loaded successfully." << endl;
-			//periode->Output((ofstream *)&cout);
-		} else {
-			cout << Verbose(0) << "Element list loading failed." << endl;
-			return 1;
-		}
-		// 3. Find config file name and parse if possible
-		if (argv[1][0] != '-') {
-			cout << Verbose(0) << "Config file given." << endl;
-			test.open(argv[1], ios::in);
-			if (test == NULL) {
-				//return (1);
-				output.open(argv[1], ios::out);
-				if (output == NULL) {
-					cout << Verbose(1) << "Specified config file " << argv[1] << " not found." << endl;
-					config_present = absent;
-				} else {
-					cout << "Empty configuration file." << endl;
-					ConfigFileName = argv[1];
-					config_present = empty;
-					output.close();
-				}
-			} else {
-				test.close();
-				ConfigFileName = argv[1];
-				cout << Verbose(1) << "Specified config file found, parsing ... ";
-				switch (configuration.TestSyntax(ConfigFileName, periode, mol)) {
-					case 1:
-						cout << "new syntax." << endl;
-						configuration.Load(ConfigFileName, periode, mol);
-						config_present = present;
-						break;
-					case 0:
-						cout << "old syntax." << endl;
-						configuration.LoadOld(ConfigFileName, periode, mol);
-						config_present = present;
-						break;
-					default:
-						cout << "Unknown syntax or empty, yet present file." << endl;
-						config_present = empty;
-			 }
-			}
-		} else
-			config_present = absent;
-		// 4. parse again through options, now for those depending on elements db and config presence
-		argptr = 1;
-		do {
-			cout << "Current Command line argument: " << argv[argptr] << "." << endl;
-			if (argv[argptr][0] == '-') {
-				argptr++;
-				if ((config_present == present) || (config_present == empty)) {
-					switch(argv[argptr-1][1]) {
-						case 'p':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-								ExitFlag = 255;
-								cerr << "Not enough arguments for parsing: -p <xyz file>" << endl;
-							} else {
-								SaveFlag = true;
-								cout << Verbose(1) << "Parsing xyz file for new atoms." << endl;
-								if (!mol->AddXYZFile(argv[argptr]))
-									cout << Verbose(2) << "File not found." << endl;
-								else {
-									cout << Verbose(2) << "File found and parsed." << endl;
-									config_present = present;
-								}
-							}
-							break;
-						case 'a':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr+1]))) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments for adding atom: -a <element> <x> <y> <z>" << endl;
-							} else {
-								SaveFlag = true;
-								cout << Verbose(1) << "Adding new atom with element " << argv[argptr] << " at (" << argv[argptr+1] << "," << argv[argptr+2] << "," << argv[argptr+3] << "), ";
-								first = new atom;
-								first->type = periode->FindElement(atoi(argv[argptr]));
-								if (first->type != NULL)
-									cout << Verbose(2) << "found element " << first->type->name << endl;
-								for (int i=NDIM;i--;)
-									first->x.x[i] = atof(argv[argptr+1+i]);
-								if (first->type != NULL) {
-									mol->AddAtom(first);	// add to molecule
-									if ((config_present == empty) && (mol->AtomCount != 0))
-										config_present = present;
-								} else
-									cerr << Verbose(1) << "Could not find the specified element." << endl;
-								argptr+=4;
-							}
-							break;
-						default:	 // no match? Don't step on (this is done in next switch's default)
-							break;
-					}
-				}
-				if (config_present == present) {
-					switch(argv[argptr-1][1]) {
-						case 'B':
-							if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for setting MPQC basis: -B <basis name>" << endl;
-							} else {
-								configuration.basis = argv[argptr];
-								cout << Verbose(1) << "Setting MPQC basis to " << configuration.basis << "." << endl;
-								argptr+=1;
-							}
-							break;
-						case 'D':
-							ExitFlag = 1;
-							{
-								cout << Verbose(1) << "Depth-First-Search Analysis." << endl;
-								MoleculeLeafClass *Subgraphs = NULL;			// list of subgraphs from DFS analysis
-								int *MinimumRingSize = new int[mol->AtomCount];
-								atom ***ListOfLocalAtoms = NULL;
-								int FragmentCounter = 0;
-								class StackClass<bond *> *BackEdgeStack = NULL;
-								class StackClass<bond *> *LocalBackEdgeStack = NULL;
-								mol->CreateAdjacencyList((ofstream *)&cout, atof(argv[argptr]), configuration.GetIsAngstroem());
-								mol->CreateListOfBondsPerAtom((ofstream *)&cout);
-								Subgraphs = mol->DepthFirstSearchAnalysis((ofstream *)&cout, BackEdgeStack);
-								if (Subgraphs != NULL) {
-									Subgraphs->next->FillBondStructureFromReference((ofstream *)&cout, mol, (FragmentCounter = 0), ListOfLocalAtoms, false);	// we want to keep the created ListOfLocalAtoms
-									while (Subgraphs->next != NULL) {
-										Subgraphs = Subgraphs->next;
-										LocalBackEdgeStack = new StackClass<bond *> (Subgraphs->Leaf->BondCount);
-										Subgraphs->Leaf->PickLocalBackEdges((ofstream *)&cout, ListOfLocalAtoms[FragmentCounter++], BackEdgeStack, LocalBackEdgeStack);
-										Subgraphs->Leaf->CyclicStructureAnalysis((ofstream *)&cout, BackEdgeStack, MinimumRingSize);
-										delete(LocalBackEdgeStack);
-										delete(Subgraphs->previous);
-									}
-									delete(Subgraphs);
-									for (int i=0;i<FragmentCounter;i++)
-										Free((void **)&ListOfLocalAtoms[FragmentCounter], "ParseCommandLineOptions: **ListOfLocalAtoms[]");
-									Free((void **)&ListOfLocalAtoms, "ParseCommandLineOptions: ***ListOfLocalAtoms");
-								}
-								delete(BackEdgeStack);
-								delete[](MinimumRingSize);
-							}
-							//argptr+=1;
-							break;
-						case 'E':
-							ExitFlag = 1;
-							if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (argv[argptr+1][0] == '-')) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for changing element: -E <atom nr.> <element>" << endl;
-							} else {
-								SaveFlag = true;
-								cout << Verbose(1) << "Changing atom " << argv[argptr] << " to element " << argv[argptr+1] << "." << endl;
-								first = mol->FindAtom(atoi(argv[argptr]));
-								first->type = periode->FindElement(atoi(argv[argptr+1]));
-								argptr+=2;
-							}
-							break;
-						case 'A':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-								ExitFlag =255;
-								cerr << "Missing source file for bonds in molecule: -A <bond sourcefile>" << endl;
-							} else {
-								cout << "Parsing bonds from " << argv[argptr] << "." << endl;
-								ifstream *input = new ifstream(argv[argptr]);
-								mol->CreateAdjacencyList2((ofstream *)&cout, input);
-								input->close();
-								argptr+=1;
-							}
-							break;
-						case 'N':
-							ExitFlag = 1;
-							if ((argptr+1 >= argc) || (argv[argptr+1][0] == '-')){
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for non-convex envelope: -o <radius> <tecplot output file>" << endl;
-							} else {
-								class Tesselation T;
-								string filename(argv[argptr+1]);
-								filename.append(".csv");
-								cout << Verbose(0) << "Evaluating non-convex envelope.";
-								cout << Verbose(1) << "Using rolling ball of radius " << atof(argv[argptr]) << " and storing tecplot data in " << argv[argptr+1] << "." << endl;
-								LinkedCell LCList(mol, atof(argv[argptr])*2.);
-								Find_non_convex_border((ofstream *)&cout, mol, &T, &LCList, argv[argptr+1], atof(argv[argptr]));
-								//FindDistributionOfEllipsoids((ofstream *)&cout, &T, &LCList, N, number, filename.c_str());
-								argptr+=2;
-							}
-							break;
-						case 'T':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for storing tempature: -T <temperature file>" << endl;
-							} else {
-								cout << Verbose(1) << "Storing temperatures in " << argv[argptr] << "." << endl;
-								ofstream *output = new ofstream(argv[argptr], ios::trunc);
-								if (!mol->OutputTemperatureFromTrajectories((ofstream *)&cout, 0, mol->MDSteps, output))
-									cout << Verbose(2) << "File could not be written." << endl;
-								else
-									cout << Verbose(2) << "File stored." << endl;
-								output->close();
-								delete(output);
-								argptr+=1;
-							}
-							break;
-						case 'P':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for parsing and integrating forces: -P <forces file>" << endl;
-							} else {
-								SaveFlag = true;
-								cout << Verbose(1) << "Parsing forces file and Verlet integrating." << endl;
-								if (!mol->VerletForceIntegration(argv[argptr], configuration.Deltat, configuration.GetIsAngstroem()))
-									cout << Verbose(2) << "File not found." << endl;
-								else
-									cout << Verbose(2) << "File found and parsed." << endl;
-								argptr+=1;
-							}
-							break;
-						case 't':
-							ExitFlag = 1;
-							if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for translation: -t <x> <y> <z>" << endl;
-							} else {
-								ExitFlag = 1;
-								SaveFlag = true;
-								cout << Verbose(1) << "Translating all ions to new origin." << endl;
-								for (int i=NDIM;i--;)
-									x.x[i] = atof(argv[argptr+i]);
-								mol->Translate((const Vector *)&x);
-								argptr+=3;
-							}
-							break;
-						case 's':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (!IsValidNumber(argv[argptr])) ) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for scaling: -s <factor/[factor_x]> [factor_y] [factor_z]" << endl;
-							} else {
-								SaveFlag = true;
-								j = -1;
-								cout << Verbose(1) << "Scaling all ion positions by factor." << endl;
-								factor = new double[NDIM];
-								factor[0] = atof(argv[argptr]);
-								if ((argptr < argc) && (IsValidNumber(argv[argptr])))
-									argptr++;
-								factor[1] = atof(argv[argptr]);
-								if ((argptr < argc) && (IsValidNumber(argv[argptr])))
-									argptr++;
-								factor[2] = atof(argv[argptr]);
-								mol->Scale(&factor);
-								for (int i=0;i<NDIM;i++) {
-									j += i+1;
-									x.x[i] = atof(argv[NDIM+i]);
-									mol->cell_size[j]*=factor[i];
-								}
-								delete[](factor);
-								argptr+=1;
-							}
-							break;
-						case 'b':
-							ExitFlag = 1;
-							if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for centering in box: -b <length_x> <length_y> <length_z>" << endl;
-							} else {
-								SaveFlag = true;
-								j = -1;
-								cout << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
-								j=-1;
-								for (int i=0;i<NDIM;i++) {
-									j += i+1;
-									x.x[i] = atof(argv[argptr++]);
-									mol->cell_size[j] += x.x[i]*2.;
-								}
-								// center
-								mol->CenterInBox((ofstream *)&cout, &x);
-								// update Box of atoms by boundary
-								mol->SetBoxDimension(&x);
-							}
-							break;
-						case 'c':
-							ExitFlag = 1;
-							if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for centering with boundary: -c <boundary_x> <boundary_y> <boundary_z>" << endl;
-							} else {
-								SaveFlag = true;
-								j = -1;
-								cout << Verbose(1) << "Centering atoms in config file within given additional boundary." << endl;
-								// make every coordinate positive
-								mol->CenterEdge((ofstream *)&cout, &x);
-								// update Box of atoms by boundary
-								mol->SetBoxDimension(&x);
-								// translate each coordinate by boundary
-								j=-1;
-								for (int i=0;i<NDIM;i++) {
-									j += i+1;
-									x.x[i] = atof(argv[argptr++]);
-									mol->cell_size[j] += x.x[i]*2.;
-								}
-								mol->Translate((const Vector *)&x);
-							}
-							break;
-						case 'O':
-							ExitFlag = 1;
-							SaveFlag = true;
-							cout << Verbose(1) << "Centering atoms in origin." << endl;
-							mol->CenterOrigin((ofstream *)&cout, &x);
-							mol->SetBoxDimension(&x);
-							break;
-						case 'r':
-							ExitFlag = 1;
-							SaveFlag = true;
-							cout << Verbose(1) << "Converting config file from supposed old to new syntax." << endl;
-							break;
-						case 'F':
-						case 'f':
-							ExitFlag = 1;
-							if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1]))) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments for fragmentation: -f <max. bond distance> <bond order>" << endl;
-							} else {
-								cout << "Fragmenting molecule with bond distance " << argv[argptr] << " angstroem, order of " << argv[argptr+1] << "." << endl;
-								cout << Verbose(0) << "Creating connection matrix..." << endl;
-								start = clock();
-								mol->CreateAdjacencyList((ofstream *)&cout, atof(argv[argptr++]), configuration.GetIsAngstroem());
-								cout << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl;
-								if (mol->first->next != mol->last) {
-									ExitFlag = mol->FragmentMolecule((ofstream *)&cout, atoi(argv[argptr]), &configuration);
-								}
-								end = clock();
-								cout << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
-								argptr+=2;
-							}
-							break;
-						case 'm':
-							ExitFlag = 1;
-							j = atoi(argv[argptr++]);
-							if ((j<0) || (j>1)) {
-								cerr << Verbose(1) << "ERROR: Argument of '-m' should be either 0 for no-rotate or 1 for rotate." << endl;
-								j = 0;
-							}
-							if (j) {
-								SaveFlag = true;
-								cout << Verbose(0) << "Converting to prinicipal axis system." << endl;
-							} else
-								cout << Verbose(0) << "Evaluating prinicipal axis." << endl;
-							mol->PrincipalAxisSystem((ofstream *)&cout, (bool)j);
-							break;
-						case 'o':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (argv[argptr][0] == '-')){
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for convex envelope: -o <tecplot output file>" << endl;
-							} else {
-								cout << Verbose(0) << "Evaluating volume of the convex envelope.";
-								cout << Verbose(1) << "Storing tecplot data in " << argv[argptr] << "." << endl;
-								VolumeOfConvexEnvelope((ofstream *)&cout, argv[argptr], &configuration, NULL, mol);
-								argptr+=1;
-							}
-							break;
-						case 'U':
-							ExitFlag = 1;
-							if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) ) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for suspension with specified volume: -U <volume> <density>" << endl;
-								volume = -1; // for case 'u': don't print error again
-							} else {
-								volume = atof(argv[argptr++]);
-								cout << Verbose(0) << "Using " << volume << " angstrom^3 as the volume instead of convex envelope one's." << endl;
-							}
-						case 'u':
-							ExitFlag = 1;
-							if ((argptr >= argc) || (!IsValidNumber(argv[argptr])) ) {
-								if (volume != -1)
-									ExitFlag = 255;
-									cerr << "Not enough arguments given for suspension: -u <density>" << endl;
-							} else {
-								double density;
-								SaveFlag = true;
-								cout << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.";
-								density = atof(argv[argptr++]);
-								if (density < 1.0) {
-									cerr << Verbose(0) << "Density must be greater than 1.0g/cm^3 !" << endl;
-									density = 1.3;
-								}
-//								for(int i=0;i<NDIM;i++) {
-//									repetition[i] = atoi(argv[argptr++]);
-//									if (repetition[i] < 1)
-//										cerr << Verbose(0) << "ERROR: repetition value must be greater 1!" << endl;
-//									repetition[i] = 1;
-//								}
-								PrepareClustersinWater((ofstream *)&cout, &configuration, mol, volume, density);	// if volume == 0, will calculate from ConvexEnvelope
-							}
-							break;
-						case 'd':
-							ExitFlag = 1;
-							if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
-								ExitFlag = 255;
-								cerr << "Not enough or invalid arguments given for repeating cells: -d <repeat_x> <repeat_y> <repeat_z>" << endl;
-							} else {
-								SaveFlag = true;
-								for (int axis = 1; axis <= NDIM; axis++) {
-									int faktor = atoi(argv[argptr++]);
-									int count;
-									element ** Elements;
-									Vector ** vectors;
-									if (faktor < 1) {
-										cerr << Verbose(0) << "ERROR: Repetition faktor mus be greater than 1!" << endl;
-										faktor = 1;
-									}
-									mol->CountAtoms((ofstream *)&cout);	// recount atoms
-									if (mol->AtomCount != 0) {	// if there is more than none
-										count = mol->AtomCount;	 // is changed becausing of adding, thus has to be stored away beforehand
-										Elements = new element *[count];
-										vectors = new Vector *[count];
-										j = 0;
-										first = mol->start;
-										while (first->next != mol->end) {	// make a list of all atoms with coordinates and element
-											first = first->next;
-											Elements[j] = first->type;
-											vectors[j] = &first->x;
-											j++;
-										}
-										if (count != j)
-											cout << Verbose(0) << "ERROR: AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl;
-										x.Zero();
-										y.Zero();
-										y.x[abs(axis)-1] = mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
-										for (int i=1;i<faktor;i++) {	// then add this list with respective translation factor times
-											x.AddVector(&y); // per factor one cell width further
-											for (int k=count;k--;) { // go through every atom of the original cell
-												first = new atom(); // create a new body
-												first->x.CopyVector(vectors[k]);	// use coordinate of original atom
-												first->x.AddVector(&x);			// translate the coordinates
-												first->type = Elements[k];	// insert original element
-												mol->AddAtom(first);				// and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
-											}
-										}
-										// free memory
-										delete[](Elements);
-										delete[](vectors);
-										// correct cell size
-										if (axis < 0) { // if sign was negative, we have to translate everything
-											x.Zero();
-											x.AddVector(&y);
-											x.Scale(-(faktor-1));
-											mol->Translate(&x);
-										}
-										mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor;
-									}
-								}
-							}
-							break;
-						default:	 // no match? Step on
-							if ((argptr < argc) && (argv[argptr][0] != '-')) // if it started with a '-' we've already made a step!
-								argptr++;
-							break;
-					}
-				}
-			} else argptr++;
-		} while (argptr < argc);
-		if (SaveFlag)
-			SaveConfig(ConfigFileName, &configuration, periode, molecules);
-	} else {	// no arguments, hence scan the elements db
-		if (periode->LoadPeriodentafel(configuration.databasepath))
-			cout << Verbose(0) << "Element list loaded successfully." << endl;
-		else
-			cout << Verbose(0) << "Element list loading failed." << endl;
-		configuration.RetrieveConfigPathAndName("main_pcp_linux");
-	}
-	return(ExitFlag);
+  if (argc > 1) { // config file specified as option
+    // 1. : Parse options that just set variables or print help
+    argptr = 1;
+    do {
+      if (argv[argptr][0] == '-') {
+        cout << Verbose(0) << "Recognized command line argument: " << argv[argptr][1] << ".\n";
+        argptr++;
+        switch(argv[argptr-1][1]) {
+          case 'h':
+          case 'H':
+          case '?':
+            cout << "MoleCuilder suite" << endl << "==================" << endl << endl;
+            cout << "Usage: " << argv[0] << "[config file] [-{acefpsthH?vfrp}] [further arguments]" << endl;
+            cout << "or simply " << argv[0] << " without arguments for interactive session." << endl;
+            cout << "\t-a Z x1 x2 x3\tAdd new atom of element Z at coordinates (x1,x2,x3)." << endl;
+            cout << "\t-A <source>\tCreate adjacency list from bonds parsed from 'dbond'-style file." <<endl;
+            cout << "\t-b xx xy xz yy yz zz\tCenter atoms in domain with given symmetric matrix of (xx,xy,xz,yy,yz,zz)." << endl;
+            cout << "\t-B <basis>\tSetting basis to store to MPQC config files." << endl;
+            cout << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl;
+            cout << "\t-D <bond distance>\tDepth-First-Search Analysis of the molecule, giving cycles and tree/back edges." << endl;
+            cout << "\t-O\tCenter atoms in origin." << endl;
+            cout << "\t-d x1 x2 x3\tDuplicate cell along each axis by given factor." << endl;
+            cout << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl;
+            cout << "\t-E <id> <Z>\tChange atom <id>'s element to <Z>, <id> begins at 0." << endl;
+            cout << "\t-f/F <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl;
+            cout << "\t-h/-H/-?\tGive this help screen." << endl;
+            cout << "\t-m <0/1>\tCalculate (0)/ Align in(1) PAS with greatest EV along z axis." << endl;
+            cout << "\t-n\tFast parsing (i.e. no trajectories are looked for)." << endl;
+            cout << "\t-N <radius> <file>\tGet non-convex-envelope." << endl;
+            cout << "\t-o <out>\tGet volume of the convex envelope (and store to tecplot file)." << endl;
+            cout << "\t-p <file>\tParse given xyz file and create raw config file from it." << endl;
+            cout << "\t-P <file>\tParse given forces file and append as an MD step to config file via Verlet." << endl;
+            cout << "\t-L <step0> <step1> <prefix>\tStore a linear interpolation between two configurations <step0> and <step1> into single config files with prefix <prefix> and as Trajectories into the current config file." << endl; 
+            cout << "\t-r\t\tConvert file from an old pcp syntax." << endl;
+            cout << "\t-R\t\tRemove all atoms out of sphere around a given one." << endl;
+            cout << "\t-t x1 x2 x3\tTranslate all atoms by this vector (x1,x2,x3)." << endl;
+            cout << "\t-T x1 x2 x3\tTranslate periodically all atoms by this vector (x1,x2,x3)." << endl;
+            cout << "\t-S <file> Store temperatures from the config file in <file>." << endl;
+            cout << "\t-s x1 x2 x3\tScale all atom coordinates by this vector (x1,x2,x3)." << endl;
+            cout << "\t-u rho\tsuspend in water solution and output necessary cell lengths, average density rho and repetition." << endl;
+            cout << "\t-v/-V\t\tGives version information." << endl;
+            cout << "Note: config files must not begin with '-' !" << endl;
+            return (1);
+            break;
+          case 'v':
+          case 'V':
+            cout << argv[0] << " " << VERSIONSTRING << endl;
+            cout << "Build your own molecule position set." << endl;
+            return (1);
+            break;
+          case 'e':
+            if ((argptr >= argc) || (argv[argptr][0] == '-')) {
+              cerr << "Not enough or invalid arguments for specifying element db: -e <db file>" << endl;
+            } else {
+              cout << "Using " << argv[argptr] << " as elements database." << endl;
+              strncpy (configuration.databasepath, argv[argptr], MAXSTRINGSIZE-1);
+              argptr+=1;
+            }
+            break;
+          case 'n':
+            cout << "I won't parse trajectories." << endl;
+            configuration.FastParsing = true;
+            break;
+          default:   // no match? Step on
+            argptr++;
+            break;
+        }
+      } else
+        argptr++;
+    } while (argptr < argc);
+
+    // 2. Parse the element database
+    if (periode->LoadPeriodentafel(configuration.databasepath)) {
+      cout << Verbose(0) << "Element list loaded successfully." << endl;
+      //periode->Output((ofstream *)&cout);
+    } else {
+      cout << Verbose(0) << "Element list loading failed." << endl;
+      return 1;
+    }
+    // 3. Find config file name and parse if possible
+    if (argv[1][0] != '-') {
+      // simply create a new molecule, wherein the config file is loaded and the manipulation takes place
+      mol = new molecule(periode);
+      mol->ActiveFlag = true;
+      molecules->insert(mol);
+
+      cout << Verbose(0) << "Config file given." << endl;
+      test.open(argv[1], ios::in);
+      if (test == NULL) {
+        //return (1);
+        output.open(argv[1], ios::out);
+        if (output == NULL) {
+          cout << Verbose(1) << "Specified config file " << argv[1] << " not found." << endl;
+          config_present = absent;
+        } else {
+          cout << "Empty configuration file." << endl;
+          ConfigFileName = argv[1];
+          config_present = empty;
+          output.close();
+        }
+      } else {
+        test.close();
+        ConfigFileName = argv[1];
+        cout << Verbose(1) << "Specified config file found, parsing ... ";
+        switch (configuration.TestSyntax(ConfigFileName, periode, mol)) {
+          case 1:
+            cout << "new syntax." << endl;
+            configuration.Load(ConfigFileName, periode, mol);
+            config_present = present;
+            break;
+          case 0:
+            cout << "old syntax." << endl;
+            configuration.LoadOld(ConfigFileName, periode, mol);
+            config_present = present;
+            break;
+          default:
+            cout << "Unknown syntax or empty, yet present file." << endl;
+            config_present = empty;
+       }
+      }
+    } else
+      config_present = absent;
+    // 4. parse again through options, now for those depending on elements db and config presence
+    argptr = 1;
+    do {
+      cout << "Current Command line argument: " << argv[argptr] << "." << endl;
+      if (argv[argptr][0] == '-') {
+        argptr++;
+        if ((config_present == present) || (config_present == empty)) {
+          switch(argv[argptr-1][1]) {
+            case 'p':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (argv[argptr][0] == '-')) {
+                ExitFlag = 255;
+                cerr << "Not enough arguments for parsing: -p <xyz file>" << endl;
+              } else {
+                SaveFlag = true;
+                cout << Verbose(1) << "Parsing xyz file for new atoms." << endl;
+                if (!mol->AddXYZFile(argv[argptr]))
+                  cout << Verbose(2) << "File not found." << endl;
+                else {
+                  cout << Verbose(2) << "File found and parsed." << endl;
+                  config_present = present;
+                }
+              }
+              break;
+            case 'a':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr+1]))) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments for adding atom: -a <element> <x> <y> <z>" << endl;
+              } else {
+                SaveFlag = true;
+                cout << Verbose(1) << "Adding new atom with element " << argv[argptr] << " at (" << argv[argptr+1] << "," << argv[argptr+2] << "," << argv[argptr+3] << "), ";
+                first = new atom;
+                first->type = periode->FindElement(atoi(argv[argptr]));
+                if (first->type != NULL)
+                  cout << Verbose(2) << "found element " << first->type->name << endl;
+                for (int i=NDIM;i--;)
+                  first->x.x[i] = atof(argv[argptr+1+i]);
+                if (first->type != NULL) {
+                  mol->AddAtom(first);  // add to molecule
+                  if ((config_present == empty) && (mol->AtomCount != 0))
+                    config_present = present;
+                } else
+                  cerr << Verbose(1) << "Could not find the specified element." << endl;
+                argptr+=4;
+              }
+              break;
+            default:   // no match? Don't step on (this is done in next switch's default)
+              break;
+          }
+        }
+        if (config_present == present) {
+          switch(argv[argptr-1][1]) {
+            case 'B':
+              if ((argptr >= argc) || (argv[argptr][0] == '-')) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for setting MPQC basis: -B <basis name>" << endl;
+              } else {
+                configuration.basis = argv[argptr];
+                cout << Verbose(1) << "Setting MPQC basis to " << configuration.basis << "." << endl;
+                argptr+=1;
+              }
+              break;
+            case 'D':
+              ExitFlag = 1;
+              {
+                cout << Verbose(1) << "Depth-First-Search Analysis." << endl;
+                MoleculeLeafClass *Subgraphs = NULL;      // list of subgraphs from DFS analysis
+                int *MinimumRingSize = new int[mol->AtomCount];
+                atom ***ListOfLocalAtoms = NULL;
+                int FragmentCounter = 0;
+                class StackClass<bond *> *BackEdgeStack = NULL;
+                class StackClass<bond *> *LocalBackEdgeStack = NULL;
+                mol->CreateAdjacencyList((ofstream *)&cout, atof(argv[argptr]), configuration.GetIsAngstroem());
+                mol->CreateListOfBondsPerAtom((ofstream *)&cout);
+                Subgraphs = mol->DepthFirstSearchAnalysis((ofstream *)&cout, BackEdgeStack);
+                if (Subgraphs != NULL) {
+                  Subgraphs->next->FillBondStructureFromReference((ofstream *)&cout, mol, (FragmentCounter = 0), ListOfLocalAtoms, false);  // we want to keep the created ListOfLocalAtoms
+                  while (Subgraphs->next != NULL) {
+                    Subgraphs = Subgraphs->next;
+                    LocalBackEdgeStack = new StackClass<bond *> (Subgraphs->Leaf->BondCount);
+                    Subgraphs->Leaf->PickLocalBackEdges((ofstream *)&cout, ListOfLocalAtoms[FragmentCounter++], BackEdgeStack, LocalBackEdgeStack);
+                    Subgraphs->Leaf->CyclicStructureAnalysis((ofstream *)&cout, BackEdgeStack, MinimumRingSize);
+                    delete(LocalBackEdgeStack);
+                    delete(Subgraphs->previous);
+                  }
+                  delete(Subgraphs);
+                  for (int i=0;i<FragmentCounter;i++)
+                    Free((void **)&ListOfLocalAtoms[FragmentCounter], "ParseCommandLineOptions: **ListOfLocalAtoms[]");
+                  Free((void **)&ListOfLocalAtoms, "ParseCommandLineOptions: ***ListOfLocalAtoms");
+                }
+                delete(BackEdgeStack);
+                delete[](MinimumRingSize);
+              }
+              //argptr+=1;
+              break;
+            case 'E':
+              ExitFlag = 1;
+              if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (argv[argptr+1][0] == '-')) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for changing element: -E <atom nr.> <element>" << endl;
+              } else {
+                SaveFlag = true;
+                cout << Verbose(1) << "Changing atom " << argv[argptr] << " to element " << argv[argptr+1] << "." << endl;
+                first = mol->FindAtom(atoi(argv[argptr]));
+                first->type = periode->FindElement(atoi(argv[argptr+1]));
+                argptr+=2;
+              }
+              break;
+            case 'A':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (argv[argptr][0] == '-')) {
+                ExitFlag =255;
+                cerr << "Missing source file for bonds in molecule: -A <bond sourcefile>" << endl;
+              } else {
+                cout << "Parsing bonds from " << argv[argptr] << "." << endl;
+                ifstream *input = new ifstream(argv[argptr]);
+                mol->CreateAdjacencyList2((ofstream *)&cout, input);
+                input->close();
+                argptr+=1;
+              }
+              break;
+            case 'N':
+              ExitFlag = 1;
+              if ((argptr+1 >= argc) || (argv[argptr+1][0] == '-')){
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for non-convex envelope: -o <radius> <tecplot output file>" << endl;
+              } else {
+                class Tesselation T;
+                string filename(argv[argptr+1]);
+                filename.append(".csv");
+                cout << Verbose(0) << "Evaluating non-convex envelope.";
+                cout << Verbose(1) << "Using rolling ball of radius " << atof(argv[argptr]) << " and storing tecplot data in " << argv[argptr+1] << "." << endl;
+                LinkedCell LCList(mol, atof(argv[argptr])*2.);
+                Find_non_convex_border((ofstream *)&cout, mol, &T, &LCList, argv[argptr+1], atof(argv[argptr]));
+                //FindDistributionOfEllipsoids((ofstream *)&cout, &T, &LCList, N, number, filename.c_str());
+                argptr+=2;
+              }
+              break;
+            case 'S':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (argv[argptr][0] == '-')) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for storing tempature: -S <temperature file>" << endl;
+              } else {
+                cout << Verbose(1) << "Storing temperatures in " << argv[argptr] << "." << endl;
+                ofstream *output = new ofstream(argv[argptr], ios::trunc);
+                if (!mol->OutputTemperatureFromTrajectories((ofstream *)&cout, 0, mol->MDSteps, output))
+                  cout << Verbose(2) << "File could not be written." << endl;
+                else
+                  cout << Verbose(2) << "File stored." << endl;
+                output->close();
+                delete(output);
+                argptr+=1;
+              }
+              break;
+            case 'L':
+              ExitFlag = 1;
+              SaveFlag = true;
+              cout << Verbose(1) << "Linear interpolation between configuration " << argv[argptr] << " and " << argv[argptr+1] << "." << endl;
+              if (!mol->LinearInterpolationBetweenConfiguration((ofstream *)&cout, atoi(argv[argptr]), atoi(argv[argptr+1]), argv[argptr+2], configuration))
+                cout << Verbose(2) << "Could not store " << argv[argptr+2] << " files." << endl;
+              else
+                cout << Verbose(2) << "Steps created and " << argv[argptr+2] << " files stored." << endl;
+              argptr+=3;
+              break;
+            case 'P':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (argv[argptr][0] == '-')) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for parsing and integrating forces: -P <forces file>" << endl;
+              } else {
+                SaveFlag = true;
+                cout << Verbose(1) << "Parsing forces file and Verlet integrating." << endl;
+                if (!mol->VerletForceIntegration((ofstream *)&cout, argv[argptr], configuration))
+                  cout << Verbose(2) << "File not found." << endl;
+                else
+                  cout << Verbose(2) << "File found and parsed." << endl;
+                argptr+=1;
+              }
+              break;
+            case 'R':
+              ExitFlag = 1;
+              if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])))  {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for removing atoms: -R <id> <distance>" << endl;
+              } else {
+                SaveFlag = true;
+                cout << Verbose(1) << "Removing atoms around " << argv[argptr] << " with radius " << argv[argptr+1] << "." << endl;
+                double tmp1 = atof(argv[argptr+1]);
+                atom *third = mol->FindAtom(atoi(argv[argptr]));
+                atom *first = mol->start;
+                if ((third != NULL) && (first != mol->end)) {
+                  atom *second = first->next;
+                  while(second != mol->end) {
+                    first = second;
+                    second = first->next;
+                    if (first->x.DistanceSquared((const Vector *)&third->x) > tmp1*tmp1) // distance to first above radius ...
+                      mol->RemoveAtom(first);
+                  }
+                } else {
+                  cerr << "Removal failed due to missing atoms on molecule or wrong id." << endl;
+                }
+                argptr+=2;
+              }
+              break;
+            case 't':
+              ExitFlag = 1;
+              if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for translation: -t <x> <y> <z>" << endl;
+              } else {
+                ExitFlag = 1;
+                SaveFlag = true;
+                cout << Verbose(1) << "Translating all ions to new origin." << endl;
+                for (int i=NDIM;i--;)
+                  x.x[i] = atof(argv[argptr+i]);
+                mol->Translate((const Vector *)&x);
+                argptr+=3;
+              }
+            case 'T':
+              ExitFlag = 1;
+              if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for periodic translation: -T <x> <y> <z>" << endl;
+              } else {
+                ExitFlag = 1;
+                SaveFlag = true;
+                cout << Verbose(1) << "Translating all ions periodically to new origin." << endl;
+                for (int i=NDIM;i--;)
+                  x.x[i] = atof(argv[argptr+i]);
+                mol->TranslatePeriodically((const Vector *)&x);
+                argptr+=3;
+              }
+              break;
+            case 's':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (!IsValidNumber(argv[argptr])) ) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for scaling: -s <factor/[factor_x]> [factor_y] [factor_z]" << endl;
+              } else {
+                SaveFlag = true;
+                j = -1;
+                cout << Verbose(1) << "Scaling all ion positions by factor." << endl;
+                factor = new double[NDIM];
+                factor[0] = atof(argv[argptr]);
+                if ((argptr < argc) && (IsValidNumber(argv[argptr])))
+                  argptr++;
+                factor[1] = atof(argv[argptr]);
+                if ((argptr < argc) && (IsValidNumber(argv[argptr])))
+                  argptr++;
+                factor[2] = atof(argv[argptr]);
+                mol->Scale(&factor);
+                for (int i=0;i<NDIM;i++) {
+                  j += i+1;
+                  x.x[i] = atof(argv[NDIM+i]);
+                  mol->cell_size[j]*=factor[i];
+                }
+                delete[](factor);
+                argptr+=1;
+              }
+              break;
+            case 'b':
+              ExitFlag = 1;
+              if ((argptr+5 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) ) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for centering in box: -b <xx> <xy> <xz> <yy> <yz> <zz>" << endl;
+              } else {
+                SaveFlag = true;
+                j = -1;
+                cout << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
+                for (int i=0;i<6;i++) {
+                  mol->cell_size[i] = atof(argv[argptr+i]);
+                }
+                // center
+                mol->CenterInBox((ofstream *)&cout);
+                argptr+=6;
+              }
+              break;
+            case 'c':
+              ExitFlag = 1;
+              if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for centering with boundary: -c <boundary_x> <boundary_y> <boundary_z>" << endl;
+              } else {
+                SaveFlag = true;
+                j = -1;
+                cout << Verbose(1) << "Centering atoms in config file within given additional boundary." << endl;
+                // make every coordinate positive
+                mol->CenterEdge((ofstream *)&cout, &x);
+                // update Box of atoms by boundary
+                mol->SetBoxDimension(&x);
+                // translate each coordinate by boundary
+                j=-1;
+                for (int i=0;i<NDIM;i++) {
+                  j += i+1;
+                  x.x[i] = atof(argv[argptr+i]);
+                  mol->cell_size[j] += x.x[i]*2.;
+                }
+                mol->Translate((const Vector *)&x);
+                argptr+=3;
+              }
+              break;
+            case 'O':
+              ExitFlag = 1;
+              SaveFlag = true;
+              cout << Verbose(1) << "Centering atoms on edge and setting box dimensions." << endl;
+              x.Zero();
+              mol->CenterEdge((ofstream *)&cout, &x);
+              mol->SetBoxDimension(&x);
+              argptr+=0;
+              break;
+            case 'r':
+              ExitFlag = 1;
+              SaveFlag = true;
+              cout << Verbose(1) << "Converting config file from supposed old to new syntax." << endl;
+              break;
+            case 'F':
+            case 'f':
+              ExitFlag = 1;
+              if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1]))) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments for fragmentation: -f <max. bond distance> <bond order>" << endl;
+              } else {
+                cout << "Fragmenting molecule with bond distance " << argv[argptr] << " angstroem, order of " << argv[argptr+1] << "." << endl;
+                cout << Verbose(0) << "Creating connection matrix..." << endl;
+                start = clock();
+                mol->CreateAdjacencyList((ofstream *)&cout, atof(argv[argptr++]), configuration.GetIsAngstroem());
+                cout << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl;
+                if (mol->first->next != mol->last) {
+                  ExitFlag = mol->FragmentMolecule((ofstream *)&cout, atoi(argv[argptr]), &configuration);
+                }
+                end = clock();
+                cout << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
+                argptr+=2;
+              }
+              break;
+            case 'm':
+              ExitFlag = 1;
+              j = atoi(argv[argptr++]);
+              if ((j<0) || (j>1)) {
+                cerr << Verbose(1) << "ERROR: Argument of '-m' should be either 0 for no-rotate or 1 for rotate." << endl;
+                j = 0;
+              }
+              if (j) {
+                SaveFlag = true;
+                cout << Verbose(0) << "Converting to prinicipal axis system." << endl;
+              } else
+                cout << Verbose(0) << "Evaluating prinicipal axis." << endl;
+              mol->PrincipalAxisSystem((ofstream *)&cout, (bool)j);
+              break;
+            case 'o':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (argv[argptr][0] == '-')){
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for convex envelope: -o <tecplot output file>" << endl;
+              } else {
+                cout << Verbose(0) << "Evaluating volume of the convex envelope.";
+                cout << Verbose(1) << "Storing tecplot data in " << argv[argptr] << "." << endl;
+                LinkedCell LCList(mol, 10.);
+                class Tesselation *TesselStruct = NULL;
+                Find_convex_border((ofstream *)&cout, mol, TesselStruct, &LCList, argv[argptr]);
+                double clustervolume = VolumeOfConvexEnvelope((ofstream *)&cout, TesselStruct, &configuration);
+                cout << Verbose(0) << "The tesselated surface area is " << clustervolume << "." << endl;
+                delete(TesselStruct);
+                argptr+=1;
+              }
+              break;
+            case 'U':
+              ExitFlag = 1;
+              if ((argptr+1 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) ) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for suspension with specified volume: -U <volume> <density>" << endl;
+                volume = -1; // for case 'u': don't print error again
+              } else {
+                volume = atof(argv[argptr++]);
+                cout << Verbose(0) << "Using " << volume << " angstrom^3 as the volume instead of convex envelope one's." << endl;
+              }
+            case 'u':
+              ExitFlag = 1;
+              if ((argptr >= argc) || (!IsValidNumber(argv[argptr])) ) {
+                if (volume != -1)
+                  ExitFlag = 255;
+                  cerr << "Not enough arguments given for suspension: -u <density>" << endl;
+              } else {
+                double density;
+                SaveFlag = true;
+                cout << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.";
+                density = atof(argv[argptr++]);
+                if (density < 1.0) {
+                  cerr << Verbose(0) << "Density must be greater than 1.0g/cm^3 !" << endl;
+                  density = 1.3;
+                }
+//                for(int i=0;i<NDIM;i++) {
+//                  repetition[i] = atoi(argv[argptr++]);
+//                  if (repetition[i] < 1)
+//                    cerr << Verbose(0) << "ERROR: repetition value must be greater 1!" << endl;
+//                  repetition[i] = 1;
+//                }
+                PrepareClustersinWater((ofstream *)&cout, &configuration, mol, volume, density);  // if volume == 0, will calculate from ConvexEnvelope
+              }
+              break;
+            case 'd':
+              ExitFlag = 1;
+              if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
+                ExitFlag = 255;
+                cerr << "Not enough or invalid arguments given for repeating cells: -d <repeat_x> <repeat_y> <repeat_z>" << endl;
+              } else {
+                SaveFlag = true;
+                for (int axis = 1; axis <= NDIM; axis++) {
+                  int faktor = atoi(argv[argptr++]);
+                  int count;
+                  element ** Elements;
+                  Vector ** vectors;
+                  if (faktor < 1) {
+                    cerr << Verbose(0) << "ERROR: Repetition faktor mus be greater than 1!" << endl;
+                    faktor = 1;
+                  }
+                  mol->CountAtoms((ofstream *)&cout);  // recount atoms
+                  if (mol->AtomCount != 0) {  // if there is more than none
+                    count = mol->AtomCount;   // is changed becausing of adding, thus has to be stored away beforehand
+                    Elements = new element *[count];
+                    vectors = new Vector *[count];
+                    j = 0;
+                    first = mol->start;
+                    while (first->next != mol->end) {  // make a list of all atoms with coordinates and element
+                      first = first->next;
+                      Elements[j] = first->type;
+                      vectors[j] = &first->x;
+                      j++;
+                    }
+                    if (count != j)
+                      cout << Verbose(0) << "ERROR: AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl;
+                    x.Zero();
+                    y.Zero();
+                    y.x[abs(axis)-1] = mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
+                    for (int i=1;i<faktor;i++) {  // then add this list with respective translation factor times
+                      x.AddVector(&y); // per factor one cell width further
+                      for (int k=count;k--;) { // go through every atom of the original cell
+                        first = new atom(); // create a new body
+                        first->x.CopyVector(vectors[k]);  // use coordinate of original atom
+                        first->x.AddVector(&x);      // translate the coordinates
+                        first->type = Elements[k];  // insert original element
+                        mol->AddAtom(first);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
+                      }
+                    }
+                    // free memory
+                    delete[](Elements);
+                    delete[](vectors);
+                    // correct cell size
+                    if (axis < 0) { // if sign was negative, we have to translate everything
+                      x.Zero();
+                      x.AddVector(&y);
+                      x.Scale(-(faktor-1));
+                      mol->Translate(&x);
+                    }
+                    mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor;
+                  }
+                }
+              }
+              break;
+            default:   // no match? Step on
+              if ((argptr < argc) && (argv[argptr][0] != '-')) // if it started with a '-' we've already made a step!
+                argptr++;
+              break;
+          }
+        }
+      } else argptr++;
+    } while (argptr < argc);
+    if (SaveFlag)
+      SaveConfig(ConfigFileName, &configuration, periode, molecules);
+  } else {  // no arguments, hence scan the elements db
+    if (periode->LoadPeriodentafel(configuration.databasepath))
+      cout << Verbose(0) << "Element list loaded successfully." << endl;
+    else
+      cout << Verbose(0) << "Element list loading failed." << endl;
+    configuration.RetrieveConfigPathAndName("main_pcp_linux");
+  }
+  return(ExitFlag);
 };
 
